<?php

namespace Pepitelabs\PWS;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'CreateShipmentRequestContainer' => '\\Pepitelabs\\PWS\\ShippingService\\CreateShipmentRequestContainer',
            'RequestContainer' => '\\Pepitelabs\\PWS\\ShippingService\\RequestContainer',
            'Shipment' => '\\Pepitelabs\\PWS\\ShippingService\\Shipment',
            'SenderInformation' => '\\Pepitelabs\\PWS\\ShippingService\\SenderInformation',
            'Address' => '\\Pepitelabs\\PWS\\ShippingService\\Address',
            'PhoneNumber' => '\\Pepitelabs\\PWS\\ShippingService\\PhoneNumber',
            'ReceiverInformation' => '\\Pepitelabs\\PWS\\ShippingService\\ReceiverInformation',
            'FromOnLabelInformation' => '\\Pepitelabs\\PWS\\ShippingService\\FromOnLabelInformation',
            'PackageInformation' => '\\Pepitelabs\\PWS\\ShippingService\\PackageInformation',
            'TotalWeight' => '\\Pepitelabs\\PWS\\ShippingService\\TotalWeight',
            'ArrayOfPiece' => '\\Pepitelabs\\PWS\\ShippingService\\ArrayOfPiece',
            'Piece' => '\\Pepitelabs\\PWS\\ShippingService\\Piece',
            'Weight' => '\\Pepitelabs\\PWS\\ShippingService\\Weight',
            'Dimension' => '\\Pepitelabs\\PWS\\ShippingService\\Dimension',
            'ArrayOfOptionIDValuePair' => '\\Pepitelabs\\PWS\\ShippingService\\ArrayOfOptionIDValuePair',
            'OptionIDValuePair' => '\\Pepitelabs\\PWS\\ShippingService\\OptionIDValuePair',
            'OptionsInformation' => '\\Pepitelabs\\PWS\\ShippingService\\OptionsInformation',
            'InternationalInformation' => '\\Pepitelabs\\PWS\\ShippingService\\InternationalInformation',
            'ArrayOfContentDetail' => '\\Pepitelabs\\PWS\\ShippingService\\ArrayOfContentDetail',
            'ContentDetail' => '\\Pepitelabs\\PWS\\ShippingService\\ContentDetail',
            'BuyerInformation' => '\\Pepitelabs\\PWS\\ShippingService\\BuyerInformation',
            'DutyInformation' => '\\Pepitelabs\\PWS\\ShippingService\\DutyInformation',
            'ReturnShipmentInformation' => '\\Pepitelabs\\PWS\\ShippingService\\ReturnShipmentInformation',
            'ReturnShipment' => '\\Pepitelabs\\PWS\\ShippingService\\ReturnShipment',
            'PaymentInformation' => '\\Pepitelabs\\PWS\\ShippingService\\PaymentInformation',
            'CreditCardInformation' => '\\Pepitelabs\\PWS\\ShippingService\\CreditCardInformation',
            'PickupInformation' => '\\Pepitelabs\\PWS\\ShippingService\\PickupInformation',
            'NotificationInformation' => '\\Pepitelabs\\PWS\\ShippingService\\NotificationInformation',
            'TrackingReferenceInformation' => '\\Pepitelabs\\PWS\\ShippingService\\TrackingReferenceInformation',
            'OtherInformation' => '\\Pepitelabs\\PWS\\ShippingService\\OtherInformation',
            'ProactiveNotification' => '\\Pepitelabs\\PWS\\ShippingService\\ProactiveNotification',
            'ArrayOfSubscription' => '\\Pepitelabs\\PWS\\ShippingService\\ArrayOfSubscription',
            'Subscription' => '\\Pepitelabs\\PWS\\ShippingService\\Subscription',
            'RequestContext' => '\\Pepitelabs\\PWS\\ShippingService\\RequestContext',
            'CreateShipmentResponseContainer' => '\\Pepitelabs\\PWS\\ShippingService\\CreateShipmentResponseContainer',
            'ResponseContainer' => '\\Pepitelabs\\PWS\\ShippingService\\ResponseContainer',
            'ResponseInformation' => '\\Pepitelabs\\PWS\\ShippingService\\ResponseInformation',
            'ArrayOfError' => '\\Pepitelabs\\PWS\\ShippingService\\ArrayOfError',
            'Error' => '\\Pepitelabs\\PWS\\ShippingService\\Error',
            'ArrayOfInformationalMessage' => '\\Pepitelabs\\PWS\\ShippingService\\ArrayOfInformationalMessage',
            'InformationalMessage' => '\\Pepitelabs\\PWS\\ShippingService\\InformationalMessage',
            'PIN' => '\\Pepitelabs\\PWS\\ShippingService\\PIN',
            'ArrayOfPIN' => '\\Pepitelabs\\PWS\\ShippingService\\ArrayOfPIN',
            'ResponseContext' => '\\Pepitelabs\\PWS\\ShippingService\\ResponseContext',
            'VoidShipmentRequestContainer' => '\\Pepitelabs\\PWS\\ShippingService\\VoidShipmentRequestContainer',
            'VoidShipmentResponseContainer' => '\\Pepitelabs\\PWS\\ShippingService\\VoidShipmentResponseContainer',
            'ValidateShipmentRequestContainer' => '\\Pepitelabs\\PWS\\ShippingService\\ValidateShipmentRequestContainer',
            'ValidateShipmentResponseContainer' => '\\Pepitelabs\\PWS\\ShippingService\\ValidateShipmentResponseContainer',
            'ConsolidateRequestContainer' => '\\Pepitelabs\\PWS\\ShippingService\\ConsolidateRequestContainer',
            'ConsolidateResponseContainer' => '\\Pepitelabs\\PWS\\ShippingService\\ConsolidateResponseContainer',
            'ValidationFault' => '\\Pepitelabs\\PWS\\ShippingService\\ValidationFault',
            'ArrayOfValidationDetail' => '\\Pepitelabs\\PWS\\ShippingService\\ArrayOfValidationDetail',
            'ValidationDetail' => '\\Pepitelabs\\PWS\\ShippingService\\ValidationDetail',
        );
    }
}
