<?php

namespace Pepitelabs\PWS\ShippingService;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInformationalMessage ShippingService
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfInformationalMessage
 * @subpackage Arrays
 */
class ArrayOfInformationalMessage extends AbstractStructArrayBase
{
    /**
     * The InformationalMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\ShippingService\InformationalMessage[]
     */
    public $InformationalMessage;
    /**
     * Constructor method for ArrayOfInformationalMessage
     * @uses ArrayOfInformationalMessage::setInformationalMessage()
     * @param \Pepitelabs\PWS\ShippingService\InformationalMessage[] $informationalMessage
     */
    public function __construct(array $informationalMessage = array())
    {
        $this
            ->setInformationalMessage($informationalMessage);
    }
    /**
     * Get InformationalMessage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\ShippingService\InformationalMessage[]|null
     */
    public function getInformationalMessage()
    {
        return isset($this->InformationalMessage) ? $this->InformationalMessage : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInformationalMessage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInformationalMessage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInformationalMessageForArrayConstraintsFromSetInformationalMessage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInformationalMessageInformationalMessageItem) {
            // validation for constraint: itemType
            if (!$arrayOfInformationalMessageInformationalMessageItem instanceof \Pepitelabs\PWS\ShippingService\InformationalMessage) {
                $invalidValues[] = is_object($arrayOfInformationalMessageInformationalMessageItem) ? get_class($arrayOfInformationalMessageInformationalMessageItem) : sprintf('%s(%s)', gettype($arrayOfInformationalMessageInformationalMessageItem), var_export($arrayOfInformationalMessageInformationalMessageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InformationalMessage property can only contain items of type \Pepitelabs\PWS\ShippingService\InformationalMessage, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InformationalMessage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ShippingService\InformationalMessage[] $informationalMessage
     * @return \Pepitelabs\PWS\ShippingService\ArrayOfInformationalMessage
     */
    public function setInformationalMessage(array $informationalMessage = array())
    {
        // validation for constraint: array
        if ('' !== ($informationalMessageArrayErrorMessage = self::validateInformationalMessageForArrayConstraintsFromSetInformationalMessage($informationalMessage))) {
            throw new \InvalidArgumentException($informationalMessageArrayErrorMessage, __LINE__);
        }
        if (is_null($informationalMessage) || (is_array($informationalMessage) && empty($informationalMessage))) {
            unset($this->InformationalMessage);
        } else {
            $this->InformationalMessage = $informationalMessage;
        }
        return $this;
    }
    /**
     * Add item to InformationalMessage value
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ShippingService\InformationalMessage $item
     * @return \Pepitelabs\PWS\ShippingService\ArrayOfInformationalMessage
     */
    public function addToInformationalMessage(\Pepitelabs\PWS\ShippingService\InformationalMessage $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pepitelabs\PWS\ShippingService\InformationalMessage) {
            throw new \InvalidArgumentException(sprintf('The InformationalMessage property can only contain items of type \Pepitelabs\PWS\ShippingService\InformationalMessage, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InformationalMessage[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pepitelabs\PWS\ShippingService\InformationalMessage|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pepitelabs\PWS\ShippingService\InformationalMessage|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pepitelabs\PWS\ShippingService\InformationalMessage|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pepitelabs\PWS\ShippingService\InformationalMessage|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pepitelabs\PWS\ShippingService\InformationalMessage|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InformationalMessage
     */
    public function getAttributeName()
    {
        return 'InformationalMessage';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ShippingService\ArrayOfInformationalMessage
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
