<?php

namespace Pepitelabs\PWS\ShippingService;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPiece ShippingService
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPiece
 * @subpackage Arrays
 */
class ArrayOfPiece extends AbstractStructArrayBase
{
    /**
     * The Piece
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\ShippingService\Piece[]
     */
    public $Piece;
    /**
     * Constructor method for ArrayOfPiece
     * @uses ArrayOfPiece::setPiece()
     * @param \Pepitelabs\PWS\ShippingService\Piece[] $piece
     */
    public function __construct(array $piece = array())
    {
        $this
            ->setPiece($piece);
    }
    /**
     * Get Piece value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\ShippingService\Piece[]|null
     */
    public function getPiece()
    {
        return isset($this->Piece) ? $this->Piece : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPiece method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPiece method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePieceForArrayConstraintsFromSetPiece(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPiecePieceItem) {
            // validation for constraint: itemType
            if (!$arrayOfPiecePieceItem instanceof \Pepitelabs\PWS\ShippingService\Piece) {
                $invalidValues[] = is_object($arrayOfPiecePieceItem) ? get_class($arrayOfPiecePieceItem) : sprintf('%s(%s)', gettype($arrayOfPiecePieceItem), var_export($arrayOfPiecePieceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Piece property can only contain items of type \Pepitelabs\PWS\ShippingService\Piece, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Piece value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ShippingService\Piece[] $piece
     * @return \Pepitelabs\PWS\ShippingService\ArrayOfPiece
     */
    public function setPiece(array $piece = array())
    {
        // validation for constraint: array
        if ('' !== ($pieceArrayErrorMessage = self::validatePieceForArrayConstraintsFromSetPiece($piece))) {
            throw new \InvalidArgumentException($pieceArrayErrorMessage, __LINE__);
        }
        if (is_null($piece) || (is_array($piece) && empty($piece))) {
            unset($this->Piece);
        } else {
            $this->Piece = $piece;
        }
        return $this;
    }
    /**
     * Add item to Piece value
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ShippingService\Piece $item
     * @return \Pepitelabs\PWS\ShippingService\ArrayOfPiece
     */
    public function addToPiece(\Pepitelabs\PWS\ShippingService\Piece $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pepitelabs\PWS\ShippingService\Piece) {
            throw new \InvalidArgumentException(sprintf('The Piece property can only contain items of type \Pepitelabs\PWS\ShippingService\Piece, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Piece[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pepitelabs\PWS\ShippingService\Piece|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pepitelabs\PWS\ShippingService\Piece|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pepitelabs\PWS\ShippingService\Piece|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pepitelabs\PWS\ShippingService\Piece|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pepitelabs\PWS\ShippingService\Piece|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Piece
     */
    public function getAttributeName()
    {
        return 'Piece';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ShippingService\ArrayOfPiece
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
