<?php

namespace Pepitelabs\PWS\ShippingService;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ValidateShipmentRequestContainer ShippingService
 * Meta information extracted from the WSDL
 * - documentation: ValidateShipmentRequest
 * - nillable: true
 * - type: tns:ValidateShipmentRequestContainer
 * @subpackage Structs
 */
class ValidateShipmentRequestContainer extends RequestContainer
{
    /**
     * The Shipment
     * Meta information extracted from the WSDL
     * - documentation: Shipment - Shipment
     * - nillable: true
     * @var \Pepitelabs\PWS\ShippingService\Shipment
     */
    public $Shipment;
    /**
     * Constructor method for ValidateShipmentRequestContainer
     * @uses ValidateShipmentRequestContainer::setShipment()
     * @param \Pepitelabs\PWS\ShippingService\Shipment $shipment
     */
    public function __construct(\Pepitelabs\PWS\ShippingService\Shipment $shipment = null)
    {
        $this
            ->setShipment($shipment);
    }
    /**
     * Get Shipment value
     * @return \Pepitelabs\PWS\ShippingService\Shipment|null
     */
    public function getShipment()
    {
        return $this->Shipment;
    }
    /**
     * Set Shipment value
     * @param \Pepitelabs\PWS\ShippingService\Shipment $shipment
     * @return \Pepitelabs\PWS\ShippingService\ValidateShipmentRequestContainer
     */
    public function setShipment(\Pepitelabs\PWS\ShippingService\Shipment $shipment = null)
    {
        $this->Shipment = $shipment;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ShippingService\ValidateShipmentRequestContainer
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
