<?php

namespace Pepitelabs\PWS\ShippingService;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ValidateShipmentResponseContainer ShippingService
 * Meta information extracted from the WSDL
 * - documentation: ValidateShipmentResponse
 * - nillable: true
 * - type: tns:ValidateShipmentResponseContainer
 * @subpackage Structs
 */
class ValidateShipmentResponseContainer extends ResponseContainer
{
    /**
     * The ValidShipment
     * Meta information extracted from the WSDL
     * - documentation: ValidShipment - bool
     * - minOccurs: 0
     * @var bool
     */
    public $ValidShipment;
    /**
     * Constructor method for ValidateShipmentResponseContainer
     * @uses ValidateShipmentResponseContainer::setValidShipment()
     * @param bool $validShipment
     */
    public function __construct($validShipment = null)
    {
        $this
            ->setValidShipment($validShipment);
    }
    /**
     * Get ValidShipment value
     * @return bool|null
     */
    public function getValidShipment()
    {
        return $this->ValidShipment;
    }
    /**
     * Set ValidShipment value
     * @param bool $validShipment
     * @return \Pepitelabs\PWS\ShippingService\ValidateShipmentResponseContainer
     */
    public function setValidShipment($validShipment = null)
    {
        // validation for constraint: boolean
        if (!is_null($validShipment) && !is_bool($validShipment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($validShipment, true), gettype($validShipment)), __LINE__);
        }
        $this->ValidShipment = $validShipment;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ShippingService\ValidateShipmentResponseContainer
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
